> ## Documentation Index
> Fetch the complete documentation index at: https://developer.kyberis.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Prioritize signals

## Scope and credits

| Requirement     | Value                 |
| --------------- | --------------------- |
| Required scopes | `read:prioritize`     |
| Credits         | 8 credits per request |


## OpenAPI

````yaml POST /v2/prioritize
openapi: 3.1.0
info:
  description: Deterministic, evidence-backed threat assessment API for machine consumers.
  title: Threat Investigator API v2
  version: 0.1.0
servers: []
security: []
paths:
  /v2/prioritize:
    post:
      tags:
        - Prioritize
      summary: Deterministic environment-aware signal prioritization
      operationId: prioritize_v2_prioritize_post
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PrioritizeRequest'
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PrioritizeResponse'
          description: Successful Response
        '422':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
          description: Validation Error
      security:
        - ApiKeyAuth: []
components:
  schemas:
    PrioritizeRequest:
      additionalProperties: false
      properties:
        agent_context:
          anyOf:
            - $ref: '#/components/schemas/AgentContext'
            - type: 'null'
        environment:
          $ref: '#/components/schemas/PrioritizeEnvironment'
        expected_categories:
          anyOf:
            - items:
                enum:
                  - vulnerability
                  - campaign
                  - actor_activity
                  - malware_activity
                  - ioc_cluster
                  - technique_cluster
                  - identity_abuse
                  - vendor_risk_cluster
                type: string
              type: array
            - type: 'null'
          title: Expected Categories
        include_debug:
          default: false
          title: Include Debug
          type: boolean
        max_items:
          default: 20
          maximum: 100
          minimum: 1
          title: Max Items
          type: integer
        seen_signal_ids:
          anyOf:
            - items:
                maxLength: 128
                type: string
              maxItems: 500
              type: array
            - type: 'null'
          title: Seen Signal Ids
        seen_since:
          anyOf:
            - format: date-time
              type: string
            - type: 'null'
          title: Seen Since
        time_window_days:
          default: 30
          maximum: 180
          minimum: 1
          title: Time Window Days
          type: integer
      required:
        - environment
      title: PrioritizeRequest
      type: object
    PrioritizeResponse:
      additionalProperties: false
      properties:
        generated_at:
          title: Generated At
          type: string
        items:
          items:
            $ref: '#/components/schemas/PrioritizeItem'
          title: Items
          type: array
        meta:
          $ref: '#/components/schemas/PrioritizeMeta'
        window_end:
          title: Window End
          type: string
        window_start:
          title: Window Start
          type: string
      required:
        - generated_at
        - window_start
        - window_end
        - items
        - meta
      title: PrioritizeResponse
      type: object
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          title: Detail
          type: array
      title: HTTPValidationError
      type: object
    AgentContext:
      additionalProperties: false
      properties:
        client:
          anyOf:
            - $ref: '#/components/schemas/AgentClientInfo'
            - type: 'null'
        constraints:
          anyOf:
            - $ref: '#/components/schemas/AgentConstraints'
            - type: 'null'
        objective:
          maxLength: 280
          minLength: 8
          title: Objective
          type: string
        parent_step_id:
          anyOf:
            - maxLength: 64
              type: string
            - type: 'null'
          title: Parent Step Id
        priority:
          anyOf:
            - enum:
                - low
                - normal
                - high
                - urgent
              type: string
            - type: 'null'
          title: Priority
        requested_outcome:
          maxLength: 280
          minLength: 3
          title: Requested Outcome
          type: string
        run_id:
          maxLength: 64
          minLength: 4
          title: Run Id
          type: string
        step_id:
          maxLength: 64
          minLength: 1
          title: Step Id
          type: string
        tags:
          anyOf:
            - items:
                type: string
              maxItems: 12
              type: array
            - type: 'null'
          title: Tags
        workflow_stage:
          enum:
            - resolve
            - evidence
            - relationships
            - assessment
            - hunt
            - hydrate
            - batch
            - finalize
            - other
          title: Workflow Stage
          type: string
      required:
        - objective
        - requested_outcome
        - workflow_stage
        - run_id
        - step_id
      title: AgentContext
      type: object
    PrioritizeEnvironment:
      additionalProperties: false
      properties:
        capabilities:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Capabilities
        cloud_providers:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Cloud Providers
        external_exposure:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: External Exposure
        geography:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Geography
        hosting_model:
          anyOf:
            - type: string
            - type: 'null'
          title: Hosting Model
        industry:
          anyOf:
            - type: string
            - type: 'null'
          title: Industry
        products:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Products
        vendors:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Vendors
      title: PrioritizeEnvironment
      type: object
    PrioritizeItem:
      additionalProperties: false
      properties:
        activity_level:
          enum:
            - none
            - observed
            - active
            - widespread
          title: Activity Level
          type: string
        category:
          enum:
            - vulnerability
            - campaign
            - actor_activity
            - malware_activity
            - ioc_cluster
            - technique_cluster
            - identity_abuse
            - vendor_risk_cluster
          title: Category
          type: string
        confidence_score:
          maximum: 1
          minimum: 0
          title: Confidence Score
          type: number
        debug:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Debug
        environment_match_reasons:
          items:
            type: string
          title: Environment Match Reasons
          type: array
        first_seen:
          anyOf:
            - type: string
            - type: 'null'
          title: First Seen
        freshness_score:
          maximum: 1
          minimum: 0
          title: Freshness Score
          type: number
        is_new_to_requester:
          title: Is New To Requester
          type: boolean
        last_seen:
          anyOf:
            - type: string
            - type: 'null'
          title: Last Seen
        novelty_score:
          maximum: 1
          minimum: 0
          title: Novelty Score
          type: number
        priority:
          enum:
            - urgent
            - high
            - medium
            - low
            - background
          title: Priority
          type: string
        priority_score:
          maximum: 1
          minimum: 0
          title: Priority Score
          type: number
        recommended_action_summary:
          title: Recommended Action Summary
          type: string
        recommended_action_type:
          enum:
            - patch
            - monitor
            - hunt
            - validate_exposure
            - review_controls
            - ignore
          title: Recommended Action Type
          type: string
        signal_id:
          title: Signal Id
          type: string
        supporting_evidence:
          items:
            $ref: '#/components/schemas/PrioritizeEvidence'
          title: Supporting Evidence
          type: array
        suppression_reasons:
          items:
            type: string
          title: Suppression Reasons
          type: array
        title:
          title: Title
          type: string
        what_changed:
          items:
            type: string
          title: What Changed
          type: array
      required:
        - signal_id
        - title
        - category
        - priority
        - priority_score
        - confidence_score
        - activity_level
        - novelty_score
        - freshness_score
        - environment_match_reasons
        - suppression_reasons
        - supporting_evidence
        - what_changed
        - recommended_action_type
        - recommended_action_summary
        - is_new_to_requester
      title: PrioritizeItem
      type: object
    PrioritizeMeta:
      additionalProperties: false
      properties:
        budget:
          anyOf:
            - $ref: '#/components/schemas/Budget'
            - type: 'null'
        candidate_count:
          minimum: 0
          title: Candidate Count
          type: integer
        implemented_categories:
          items:
            enum:
              - vulnerability
              - campaign
              - actor_activity
              - malware_activity
              - ioc_cluster
              - technique_cluster
              - identity_abuse
              - vendor_risk_cluster
            type: string
          title: Implemented Categories
          type: array
        ranked_count:
          minimum: 0
          title: Ranked Count
          type: integer
        requested_categories:
          items:
            enum:
              - vulnerability
              - campaign
              - actor_activity
              - malware_activity
              - ioc_cluster
              - technique_cluster
              - identity_abuse
              - vendor_risk_cluster
            type: string
          title: Requested Categories
          type: array
        truncated:
          title: Truncated
          type: boolean
        unimplemented_categories:
          items:
            enum:
              - vulnerability
              - campaign
              - actor_activity
              - malware_activity
              - ioc_cluster
              - technique_cluster
              - identity_abuse
              - vendor_risk_cluster
            type: string
          title: Unimplemented Categories
          type: array
      required:
        - candidate_count
        - ranked_count
        - truncated
        - requested_categories
        - implemented_categories
        - unimplemented_categories
      title: PrioritizeMeta
      type: object
    ValidationError:
      properties:
        ctx:
          title: Context
          type: object
        input:
          title: Input
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          title: Location
          type: array
        msg:
          title: Message
          type: string
        type:
          title: Error Type
          type: string
      required:
        - loc
        - msg
        - type
      title: ValidationError
      type: object
    AgentClientInfo:
      additionalProperties: false
      properties:
        agent_name:
          anyOf:
            - maxLength: 64
              type: string
            - type: 'null'
          title: Agent Name
        agent_version:
          anyOf:
            - maxLength: 32
              type: string
            - type: 'null'
          title: Agent Version
        framework:
          anyOf:
            - maxLength: 32
              type: string
            - type: 'null'
          title: Framework
      title: AgentClientInfo
      type: object
    AgentConstraints:
      additionalProperties: false
      properties:
        latency_budget_ms:
          anyOf:
            - maximum: 30000
              minimum: 50
              type: integer
            - type: 'null'
          title: Latency Budget Ms
        max_results_budget:
          anyOf:
            - maximum: 200
              minimum: 1
              type: integer
            - type: 'null'
          title: Max Results Budget
        min_resolution_confidence:
          anyOf:
            - maximum: 1
              minimum: 0
              type: number
            - type: 'null'
          title: Min Resolution Confidence
        strict_mode:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Strict Mode
      title: AgentConstraints
      type: object
    PrioritizeEvidence:
      additionalProperties: false
      properties:
        evidence_id:
          title: Evidence Id
          type: string
        evidence_type:
          title: Evidence Type
          type: string
        published_at:
          anyOf:
            - type: string
            - type: 'null'
          title: Published At
        source:
          anyOf:
            - type: string
            - type: 'null'
          title: Source
      required:
        - evidence_id
        - evidence_type
      title: PrioritizeEvidence
      type: object
    Budget:
      additionalProperties: false
      properties:
        candidate_limit_per_category:
          minimum: 1
          title: Candidate Limit Per Category
          type: integer
        candidate_limit_total:
          minimum: 1
          title: Candidate Limit Total
          type: integer
        report_ids_per_candidate:
          minimum: 1
          title: Report Ids Per Candidate
          type: integer
        supporting_reports_per_item:
          minimum: 1
          title: Supporting Reports Per Item
          type: integer
      required:
        - candidate_limit_per_category
        - candidate_limit_total
        - report_ids_per_candidate
        - supporting_reports_per_item
      title: Budget
      type: object
  securitySchemes:
    ApiKeyAuth:
      description: ApiKey <key_id>:<secret>
      in: header
      name: Authorization
      type: apiKey

````